##// END OF EJS Templates
- fix a variable syntax...
Unknown -
r302:9de2b1d4943c
parent child
Show More
@@ -1,61 +1,62
1 #
1 #
2 # Setup APT repositories
2 # Setup APT repositories
3 #
3 #
4
4
5 # Load utility functions
5 # Load utility functions
6 . ./functions.sh
6 . ./functions.sh
7
7
8 # Install and setup APT proxy configuration
8 # Install and setup APT proxy configuration
9 if [ -z "$APT_PROXY" ] ; then
9 if [ -z "$APT_PROXY" ] ; then
10 install_readonly files/apt/10proxy "${ETC_DIR}/apt/apt.conf.d/10proxy"
10 install_readonly files/apt/10proxy "${ETC_DIR}/apt/apt.conf.d/10proxy"
11 sed -i "s/\"\"/\"${APT_PROXY}\"/" "${ETC_DIR}/apt/apt.conf.d/10proxy"
11 sed -i "s/\"\"/\"${APT_PROXY}\"/" "${ETC_DIR}/apt/apt.conf.d/10proxy"
12 fi
12 fi
13
13
14 if [ "$BUILD_KERNEL" = false ] ; then
14 if [ "$BUILD_KERNEL" = false ] ; then
15 if [ RPI_MODEL = 2 ] ; then
15 if [ "$RPI_MODEL" = 2 ] ; then
16 # Install APT pinning configuration for flash-kernel package
16 # Install APT pinning configuration for flash-kernel package
17 install_readonly files/apt/flash-kernel "${ETC_DIR}/apt/preferences.d/flash-kernel"
17 install_readonly files/apt/flash-kernel "${ETC_DIR}/apt/preferences.d/flash-kernel"
18
18
19 # Install APT sources.list
19 # Install APT sources.list
20 install_readonly files/apt/sources.list "${ETC_DIR}/apt/sources.list"
20 install_readonly files/apt/sources.list "${ETC_DIR}/apt/sources.list"
21 echo "deb ${COLLABORA_URL} ${RELEASE} rpi2" >> "${ETC_DIR}/apt/sources.list"
21 echo "deb ${COLLABORA_URL} ${RELEASE} rpi2" >> "${ETC_DIR}/apt/sources.list"
22
22
23 # Upgrade collabora package index and install collabora keyring
23 # Upgrade collabora package index and install collabora keyring
24 chroot_exec apt-get -qq -y update
24 chroot_exec apt-get -qq -y update
25 chroot_exec apt-get -qq -y --allow-unauthenticated install collabora-obs-archive-keyring
25 chroot_exec apt-get -qq -y --allow-unauthenticated install collabora-obs-archive-keyring
26 # if RPI_MODEL = [0] || [1] || [1P]
26 # if RPI_MODEL = [0] || [1] || [1P]
27 else
27 else
28 echo "error: ATM there is just a precompiled kernel for model 2";
28 # insert apt configuration for precompiled kernel repository for RPI 0,1,1P
29 # insert apt configuration for precompiled kernel repository for RPI 0,1,1P
29 fi
30 fi
30
31
31 else # BUILD_KERNEL=true
32 else # BUILD_KERNEL=true
32 # Install APT sources.list
33 # Install APT sources.list
33 install_readonly files/apt/sources.list "${ETC_DIR}/apt/sources.list"
34 install_readonly files/apt/sources.list "${ETC_DIR}/apt/sources.list"
34
35
35 # Use specified APT server and release
36 # Use specified APT server and release
36 sed -i "s/\/ftp.debian.org\//\/${APT_SERVER}\//" "${ETC_DIR}/apt/sources.list"
37 sed -i "s/\/ftp.debian.org\//\/${APT_SERVER}\//" "${ETC_DIR}/apt/sources.list"
37 sed -i "s/ jessie/ ${RELEASE}/" "${ETC_DIR}/apt/sources.list"
38 sed -i "s/ jessie/ ${RELEASE}/" "${ETC_DIR}/apt/sources.list"
38 fi
39 fi
39
40
40 # Allow the installation of non-free Debian packages
41 # Allow the installation of non-free Debian packages
41 if [ "$ENABLE_NONFREE" = true ] ; then
42 if [ "$ENABLE_NONFREE" = true ] ; then
42 sed -i "s/ contrib/ contrib non-free/" "${ETC_DIR}/apt/sources.list"
43 sed -i "s/ contrib/ contrib non-free/" "${ETC_DIR}/apt/sources.list"
43 fi
44 fi
44
45
45 # Upgrade package index and update all installed packages and changed dependencies
46 # Upgrade package index and update all installed packages and changed dependencies
46 chroot_exec apt-get -qq -y update
47 chroot_exec apt-get -qq -y update
47 chroot_exec apt-get -qq -y -u dist-upgrade
48 chroot_exec apt-get -qq -y -u dist-upgrade
48
49
49 if [ "$APT_INCLUDES_LATE" ] ; then
50 if [ "$APT_INCLUDES_LATE" ] ; then
50 chroot_exec apt-get -qq -y install $(echo $APT_INCLUDES_LATE |tr , ' ')
51 chroot_exec apt-get -qq -y install $(echo $APT_INCLUDES_LATE |tr , ' ')
51 fi
52 fi
52
53
53 if [ -d packages ] ; then
54 if [ -d packages ] ; then
54 for package in packages/*.deb ; do
55 for package in packages/*.deb ; do
55 cp $package ${R}/tmp
56 cp $package ${R}/tmp
56 chroot_exec dpkg --unpack /tmp/$(basename $package)
57 chroot_exec dpkg --unpack /tmp/$(basename $package)
57 done
58 done
58 fi
59 fi
59 chroot_exec apt-get -qq -y -f install
60 chroot_exec apt-get -qq -y -f install
60
61
61 chroot_exec apt-get -qq -y check
62 chroot_exec apt-get -qq -y check
@@ -1,768 +1,769
1 #!/bin/sh
1 #!/bin/sh
2
2
3 ########################################################################
3 ########################################################################
4 # rpi23-gen-image.sh 2015-2017
4 # rpi23-gen-image.sh 2015-2017
5 #
5 #
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 #
7 #
8 # This program is free software; you can redistribute it and/or
8 # This program is free software; you can redistribute it and/or
9 # modify it under the terms of the GNU General Public License
9 # modify it under the terms of the GNU General Public License
10 # as published by the Free Software Foundation; either version 2
10 # as published by the Free Software Foundation; either version 2
11 # of the License, or (at your option) any later version.
11 # of the License, or (at your option) any later version.
12 #
12 #
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 #
14 #
15 # Big thanks for patches and enhancements by 20+ github contributors!
15 # Big thanks for patches and enhancements by 20+ github contributors!
16 ########################################################################
16 ########################################################################
17
17
18 # Are we running as root?
18 # Are we running as root?
19 if [ "$(id -u)" -ne "0" ] ; then
19 if [ "$(id -u)" -ne "0" ] ; then
20 echo "error: this script must be executed with root privileges!"
20 echo "error: this script must be executed with root privileges!"
21 exit 1
21 exit 1
22 fi
22 fi
23
23
24 # Check if ./functions.sh script exists
24 # Check if ./functions.sh script exists
25 if [ ! -r "./functions.sh" ] ; then
25 if [ ! -r "./functions.sh" ] ; then
26 echo "error: './functions.sh' required script not found!"
26 echo "error: './functions.sh' required script not found!"
27 exit 1
27 exit 1
28 fi
28 fi
29
29
30 # Load utility functions
30 # Load utility functions
31 . ./functions.sh
31 . ./functions.sh
32
32
33 # Load parameters from configuration template file
33 # Load parameters from configuration template file
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 use_template
35 use_template
36 fi
36 fi
37
37
38 # Introduce settings
38 # Introduce settings
39 set -e
39 set -e
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 set -x
41 set -x
42
42
43 # Raspberry Pi model configuration
43 # Raspberry Pi model configuration
44 RPI_MODEL=${RPI_MODEL:=2}
44 RPI_MODEL=${RPI_MODEL:=2}
45
45
46 # Debian release
46 # Debian release
47 RELEASE=${RELEASE:=jessie}
47 RELEASE=${RELEASE:=jessie}
48
48
49 #Kernel Branch
49 #Kernel Branch
50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
51
51
52 # URLs
52 # URLs
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59
59
60 # Build directories
60 # Build directories
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
62 BUILDDIR="${BASEDIR}/build"
62 BUILDDIR="${BASEDIR}/build"
63
63
64 # Prepare date string for default image file name
64 # Prepare date string for default image file name
65 DATE="$(date +%Y-%m-%d)"
65 DATE="$(date +%Y-%m-%d)"
66 if [ -z "$KERNEL_BRANCH" ] ; then
66 if [ -z "$KERNEL_BRANCH" ] ; then
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
68 else
68 else
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
70 fi
70 fi
71
71
72 # Chroot directories
72 # Chroot directories
73 R="${BUILDDIR}/chroot"
73 R="${BUILDDIR}/chroot"
74 ETC_DIR="${R}/etc"
74 ETC_DIR="${R}/etc"
75 LIB_DIR="${R}/lib"
75 LIB_DIR="${R}/lib"
76 BOOT_DIR="${R}/boot/firmware"
76 BOOT_DIR="${R}/boot/firmware"
77 KERNEL_DIR="${R}/usr/src/linux"
77 KERNEL_DIR="${R}/usr/src/linux"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
79
79
80 # Firmware directory: Blank if download from github
80 # Firmware directory: Blank if download from github
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82
82
83 # General settings
83 # General settings
84 SET_ARCH=${SET_ARCH}
84 SET_ARCH=${SET_ARCH}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
86 PASSWORD=${PASSWORD:=raspberry}
86 PASSWORD=${PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
90 EXPANDROOT=${EXPANDROOT:=true}
90 EXPANDROOT=${EXPANDROOT:=true}
91
91
92 # Keyboard settings
92 # Keyboard settings
93 XKB_MODEL=${XKB_MODEL:=""}
93 XKB_MODEL=${XKB_MODEL:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
97
97
98 # Network settings (DHCP)
98 # Network settings (DHCP)
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
100
100
101 # Network settings (static)
101 # Network settings (static)
102 NET_ADDRESS=${NET_ADDRESS:=""}
102 NET_ADDRESS=${NET_ADDRESS:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
109
109
110 # APT settings
110 # APT settings
111 APT_PROXY=${APT_PROXY:=""}
111 APT_PROXY=${APT_PROXY:=""}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
113
113
114 # Feature settings
114 # Feature settings
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
116 ENABLE_I2C=${ENABLE_I2C:=false}
116 ENABLE_I2C=${ENABLE_I2C:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
127 ENABLE_WM=${ENABLE_WM:=""}
127 ENABLE_WM=${ENABLE_WM:=""}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
130 USER_NAME=${USER_NAME:="pi"}
130 USER_NAME=${USER_NAME:="pi"}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
133
133
134 # SSH settings
134 # SSH settings
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
140
140
141 # Advanced settings
141 # Advanced settings
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
154
154
155 # Kernel compilation settings
155 # Kernel compilation settings
156 BUILD_KERNEL=${BUILD_KERNEL:=false}
156 BUILD_KERNEL=${BUILD_KERNEL:=true}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
164
164
165 # Kernel compilation from source directory settings
165 # Kernel compilation from source directory settings
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
170
170
171 # Reduce disk usage settings
171 # Reduce disk usage settings
172 REDUCE_APT=${REDUCE_APT:=true}
172 REDUCE_APT=${REDUCE_APT:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
175 REDUCE_VIM=${REDUCE_VIM:=false}
175 REDUCE_VIM=${REDUCE_VIM:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
180
180
181 # Encrypted filesystem settings
181 # Encrypted filesystem settings
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
187
187
188 # Chroot scripts directory
188 # Chroot scripts directory
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
190
190
191 # Packages required in the chroot build environment
191 # Packages required in the chroot build environment
192 APT_INCLUDES=${APT_INCLUDES:=""}
192 APT_INCLUDES=${APT_INCLUDES:=""}
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
194
194
195 # Packages required for bootstrapping
195 # Packages required for bootstrapping
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
197 MISSING_PACKAGES=""
197 MISSING_PACKAGES=""
198
198
199 # Packages installed for c/c++ build environment in chroot (keep empty)
199 # Packages installed for c/c++ build environment in chroot (keep empty)
200 COMPILER_PACKAGES=""
200 COMPILER_PACKAGES=""
201
201
202 set +x
202 set +x
203
203
204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
205 if [ -n "$SET_ARCH" ] ; then
205 if [ -n "$SET_ARCH" ] ; then
206 echo "Setting Architecture specific settings"
206 echo "Setting Architecture specific settings"
207 ##################################
207 ##################################
208 # 64 bit config
208 # 64 bit config
209 ##################################
209 ##################################
210 if [ "$SET_ARCH" = 64 ] ; then
210 if [ "$SET_ARCH" = 64 ] ; then
211 echo "64 bit mode selected - Setting up enviroment"
211 echo "64 bit mode selected - Setting up enviroment"
212 # 64 bit depended settings
212 # 64 bit depended settings
213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
219
219
220 if ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]) ; then
220 if ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]) ; then
221 # RPI 3 serie specific settings
221 # RPI 3 serie specific settings
222 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
222 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
223 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
223 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
224
224
225 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
225 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
226 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
226 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
227 else
227 else
228 echo "error: At the moment Raspberry PI 3 and 3B+ are the only Models which support 64bit"
228 echo "error: At the moment Raspberry PI 3 and 3B+ are the only Models which support 64bit"
229 exit 1
229 exit 1
230 fi
230 fi
231 fi
231 fi
232
232
233 ##################################
233 ##################################
234 # 32 bit config
234 # 32 bit config
235 ##################################
235 ##################################
236 if [ "$SET_ARCH" = 32 ] ; then
236 if [ "$SET_ARCH" = 32 ] ; then
237 echo "32 bit mode selected - Setting up enviroment"
237 echo "32 bit mode selected - Setting up enviroment"
238 #General 32bit configuration
238 #General 32bit configuration
239 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
239 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
240 KERNEL_ARCH=${KERNEL_ARCH:=arm}
240 KERNEL_ARCH=${KERNEL_ARCH:=arm}
241 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
241 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
242
242
243 #Raspberry setting grouped by board compability
243 #Raspberry setting grouped by board compability
244 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
244 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
245 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
245 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
246 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
246 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
247 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
247 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
248 RELEASE_ARCH=${RELEASE_ARCH:=armel}
248 RELEASE_ARCH=${RELEASE_ARCH:=armel}
249 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
249 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
250 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
250 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
251 fi
251 fi
252 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
252 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
253 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
253 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
254 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
254 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
255 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
255 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
256 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
256 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
257 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
257 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
258 fi
258 fi
259
259
260 #Device specific configuration
260 #Device specific configuration
261 case "$RPI_MODEL" in
261 case "$RPI_MODEL" in
262 0)
262 0)
263 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
263 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
264 1)
264 1)
265 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
265 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
266 1P)
266 1P)
267 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
267 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
268 2)
268 2)
269 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
269 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
270 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
270 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
271 #Precompiled Kernel rpi2
271 #Precompiled Kernel rpi2
272 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
272 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
273 ;;
273 ;;
274 3)
274 3)
275 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
275 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
276 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
276 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
277 ;;
277 ;;
278 3P)
278 3P)
279 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
279 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
280 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
280 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
281 ;;
281 ;;
282 *)
282 *)
283 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
283 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
284 exit 1
284 exit 1
285 ;;
285 ;;
286 esac
286 esac
287 #end 32 bit
287 #end 32 bit
288 fi
288 fi
289 #SET_ARCH not set
289 #SET_ARCH not set
290 else
290 else
291 echo "error: Please set '32' or '64' as value for SET_ARCH"
291 echo "error: Please set '32' or '64' as value for SET_ARCH"
292 exit 1
292 exit 1
293 fi
293 fi
294
294
295 # Check if the internal wireless interface is supported by the RPi model
295 # Check if the internal wireless interface is supported by the RPi model
296 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
296 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
297 echo "error: The selected Raspberry Pi model has no internal wireless interface"
297 echo "error: The selected Raspberry Pi model has no internal wireless interface"
298 exit 1
298 exit 1
299 else
299 else
300 echo "Raspberry Pi model"
300 echo "Raspberry Pi model"
301 fi
301 fi
302
302
303 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
303 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
304 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
304 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
305 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
305 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
306 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
306 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
307 exit 1
307 exit 1
308 fi
308 fi
309 fi
309 fi
310
310
311 # Add libncurses5 to enable kernel menuconfig
311 # Add libncurses5 to enable kernel menuconfig
312 if [ "$KERNEL_MENUCONFIG" = true ] ; then
312 if [ "$KERNEL_MENUCONFIG" = true ] ; then
313 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
313 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
314 fi
314 fi
315
315
316 # Add ccache compiler cache for (faster) kernel cross (re)compilation
316 # Add ccache compiler cache for (faster) kernel cross (re)compilation
317 if [ "$KERNEL_CCACHE" = true ] ; then
317 if [ "$KERNEL_CCACHE" = true ] ; then
318 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
318 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
319 fi
319 fi
320
320
321 # Add cryptsetup package to enable filesystem encryption
321 # Add cryptsetup package to enable filesystem encryption
322 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
322 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
323 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
323 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
324 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
324 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
325
325
326 if [ -z "$CRYPTFS_PASSWORD" ] ; then
326 if [ -z "$CRYPTFS_PASSWORD" ] ; then
327 echo "error: no password defined (CRYPTFS_PASSWORD)!"
327 echo "error: no password defined (CRYPTFS_PASSWORD)!"
328 exit 1
328 exit 1
329 fi
329 fi
330 ENABLE_INITRAMFS=true
330 ENABLE_INITRAMFS=true
331 fi
331 fi
332
332
333 # Add initramfs generation tools
333 # Add initramfs generation tools
334 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
334 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
335 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
335 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
336 fi
336 fi
337
337
338 # Add device-tree-compiler required for building the U-Boot bootloader
338 # Add device-tree-compiler required for building the U-Boot bootloader
339 if [ "$ENABLE_UBOOT" = true ] ; then
339 if [ "$ENABLE_UBOOT" = true ] ; then
340 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
340 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
341 fi
341 fi
342
342
343 # Check if root SSH (v2) public key file exists
343 # Check if root SSH (v2) public key file exists
344 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
344 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
345 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
345 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
346 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
346 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
347 exit 1
347 exit 1
348 fi
348 fi
349 fi
349 fi
350
350
351 # Check if $USER_NAME SSH (v2) public key file exists
351 # Check if $USER_NAME SSH (v2) public key file exists
352 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
352 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
353 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
353 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
354 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
354 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
355 exit 1
355 exit 1
356 fi
356 fi
357 fi
357 fi
358
358
359 # Check if all required packages are installed on the build system
359 # Check if all required packages are installed on the build system
360 for package in $REQUIRED_PACKAGES ; do
360 for package in $REQUIRED_PACKAGES ; do
361 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
361 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
362 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
362 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
363 fi
363 fi
364 done
364 done
365
365
366 # If there are missing packages ask confirmation for install, or exit
366 # If there are missing packages ask confirmation for install, or exit
367 if [ -n "$MISSING_PACKAGES" ] ; then
367 if [ -n "$MISSING_PACKAGES" ] ; then
368 echo "the following packages needed by this script are not installed:"
368 echo "the following packages needed by this script are not installed:"
369 echo "$MISSING_PACKAGES"
369 echo "$MISSING_PACKAGES"
370
370
371 echo -n "\ndo you want to install the missing packages right now? [y/n] "
371 echo -n "\ndo you want to install the missing packages right now? [y/n] "
372 read confirm
372 read confirm
373 [ "$confirm" != "y" ] && exit 1
373 [ "$confirm" != "y" ] && exit 1
374
374
375 # Make sure all missing required packages are installed
375 # Make sure all missing required packages are installed
376 apt-get -qq -y install ${MISSING_PACKAGES}
376 apt-get -qq -y install ${MISSING_PACKAGES}
377 fi
377 fi
378
378
379 # Check if ./bootstrap.d directory exists
379 # Check if ./bootstrap.d directory exists
380 if [ ! -d "./bootstrap.d/" ] ; then
380 if [ ! -d "./bootstrap.d/" ] ; then
381 echo "error: './bootstrap.d' required directory not found!"
381 echo "error: './bootstrap.d' required directory not found!"
382 exit 1
382 exit 1
383 fi
383 fi
384
384
385 # Check if ./files directory exists
385 # Check if ./files directory exists
386 if [ ! -d "./files/" ] ; then
386 if [ ! -d "./files/" ] ; then
387 echo "error: './files' required directory not found!"
387 echo "error: './files' required directory not found!"
388 exit 1
388 exit 1
389 fi
389 fi
390
390
391 # Check if specified KERNELSRC_DIR directory exists
391 # Check if specified KERNELSRC_DIR directory exists
392 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
392 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
393 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
393 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
394 exit 1
394 exit 1
395 fi
395 fi
396
396
397 # Check if specified UBOOTSRC_DIR directory exists
397 # Check if specified UBOOTSRC_DIR directory exists
398 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
398 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
399 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
399 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
400 exit 1
400 exit 1
401 fi
401 fi
402
402
403 # Check if specified FBTURBOSRC_DIR directory exists
403 # Check if specified FBTURBOSRC_DIR directory exists
404 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
404 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
405 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
405 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
406 exit 1
406 exit 1
407 fi
407 fi
408
408
409 # Check if specified CHROOT_SCRIPTS directory exists
409 # Check if specified CHROOT_SCRIPTS directory exists
410 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
410 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
411 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
411 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
412 exit 1
412 exit 1
413 fi
413 fi
414
414
415 # Check if specified device mapping already exists (will be used by cryptsetup)
415 # Check if specified device mapping already exists (will be used by cryptsetup)
416 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
416 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
417 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
417 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
418 exit 1
418 exit 1
419 fi
419 fi
420
420
421 # Don't clobber an old build
421 # Don't clobber an old build
422 if [ -e "$BUILDDIR" ] ; then
422 if [ -e "$BUILDDIR" ] ; then
423 echo "error: directory ${BUILDDIR} already exists, not proceeding"
423 echo "error: directory ${BUILDDIR} already exists, not proceeding"
424 exit 1
424 exit 1
425 fi
425 fi
426
426
427 # Setup chroot directory
427 # Setup chroot directory
428 mkdir -p "${R}"
428 mkdir -p "${R}"
429
429
430 # Check if build directory has enough of free disk space >512MB
430 # Check if build directory has enough of free disk space >512MB
431 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
431 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
432 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
432 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
433 exit 1
433 exit 1
434 fi
434 fi
435
435
436 set -x
436 set -x
437
437
438 # Call "cleanup" function on various signals and errors
438 # Call "cleanup" function on various signals and errors
439 trap cleanup 0 1 2 3 6
439 trap cleanup 0 1 2 3 6
440
440
441 # Add required packages for the minbase installation
441 # Add required packages for the minbase installation
442 if [ "$ENABLE_MINBASE" = true ] ; then
442 if [ "$ENABLE_MINBASE" = true ] ; then
443 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
443 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
444 fi
444 fi
445
445
446 # Add required locales packages
446 # Add required locales packages
447 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
447 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
448 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
448 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
449 fi
449 fi
450
450
451 # Add parted package, required to get partprobe utility
451 # Add parted package, required to get partprobe utility
452 if [ "$EXPANDROOT" = true ] ; then
452 if [ "$EXPANDROOT" = true ] ; then
453 APT_INCLUDES="${APT_INCLUDES},parted"
453 APT_INCLUDES="${APT_INCLUDES},parted"
454 fi
454 fi
455
455
456 # Add dbus package, recommended if using systemd
456 # Add dbus package, recommended if using systemd
457 if [ "$ENABLE_DBUS" = true ] ; then
457 if [ "$ENABLE_DBUS" = true ] ; then
458 APT_INCLUDES="${APT_INCLUDES},dbus"
458 APT_INCLUDES="${APT_INCLUDES},dbus"
459 fi
459 fi
460
460
461 # Add iptables IPv4/IPv6 package
461 # Add iptables IPv4/IPv6 package
462 if [ "$ENABLE_IPTABLES" = true ] ; then
462 if [ "$ENABLE_IPTABLES" = true ] ; then
463 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
463 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
464 fi
464 fi
465
465
466 # Add openssh server package
466 # Add openssh server package
467 if [ "$ENABLE_SSHD" = true ] ; then
467 if [ "$ENABLE_SSHD" = true ] ; then
468 APT_INCLUDES="${APT_INCLUDES},openssh-server"
468 APT_INCLUDES="${APT_INCLUDES},openssh-server"
469 fi
469 fi
470
470
471 # Add alsa-utils package
471 # Add alsa-utils package
472 if [ "$ENABLE_SOUND" = true ] ; then
472 if [ "$ENABLE_SOUND" = true ] ; then
473 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
473 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
474 fi
474 fi
475
475
476 # Add rng-tools package
476 # Add rng-tools package
477 if [ "$ENABLE_HWRANDOM" = true ] ; then
477 if [ "$ENABLE_HWRANDOM" = true ] ; then
478 APT_INCLUDES="${APT_INCLUDES},rng-tools"
478 APT_INCLUDES="${APT_INCLUDES},rng-tools"
479 fi
479 fi
480
480
481 # Add fbturbo video driver
481 # Add fbturbo video driver
482 if [ "$ENABLE_FBTURBO" = true ] ; then
482 if [ "$ENABLE_FBTURBO" = true ] ; then
483 # Enable xorg package dependencies
483 # Enable xorg package dependencies
484 ENABLE_XORG=true
484 ENABLE_XORG=true
485 fi
485 fi
486
486
487 # Add user defined window manager package
487 # Add user defined window manager package
488 if [ -n "$ENABLE_WM" ] ; then
488 if [ -n "$ENABLE_WM" ] ; then
489 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
489 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
490
490
491 # Enable xorg package dependencies
491 # Enable xorg package dependencies
492 ENABLE_XORG=true
492 ENABLE_XORG=true
493 fi
493 fi
494
494
495 # Add xorg package
495 # Add xorg package
496 if [ "$ENABLE_XORG" = true ] ; then
496 if [ "$ENABLE_XORG" = true ] ; then
497 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
497 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
498 fi
498 fi
499
499
500 # Replace selected packages with smaller clones
500 # Replace selected packages with smaller clones
501 if [ "$ENABLE_REDUCE" = true ] ; then
501 if [ "$ENABLE_REDUCE" = true ] ; then
502 # Add levee package instead of vim-tiny
502 # Add levee package instead of vim-tiny
503 if [ "$REDUCE_VIM" = true ] ; then
503 if [ "$REDUCE_VIM" = true ] ; then
504 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
504 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
505 fi
505 fi
506
506
507 # Add dropbear package instead of openssh-server
507 # Add dropbear package instead of openssh-server
508 if [ "$REDUCE_SSHD" = true ] ; then
508 if [ "$REDUCE_SSHD" = true ] ; then
509 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
509 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
510 fi
510 fi
511 fi
511 fi
512
512
513 #backwards compability to jessie - untested
513 if [ "$RELEASE" != "jessie" ] ; then
514 if [ "$RELEASE" != "jessie" ] ; then
514 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
515 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
515 fi
516 fi
516
517
517 # Configure kernel sources if no KERNELSRC_DIR
518 # Configure kernel sources if no KERNELSRC_DIR
518 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
519 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
519 KERNELSRC_CONFIG=true
520 KERNELSRC_CONFIG=true
520 fi
521 fi
521
522
522 # Configure reduced kernel
523 # Configure reduced kernel
523 if [ "$KERNEL_REDUCE" = true ] ; then
524 if [ "$KERNEL_REDUCE" = true ] ; then
524 KERNELSRC_CONFIG=false
525 KERNELSRC_CONFIG=false
525 fi
526 fi
526
527
527 # Execute bootstrap scripts
528 # Execute bootstrap scripts
528 for SCRIPT in bootstrap.d/*.sh; do
529 for SCRIPT in bootstrap.d/*.sh; do
529 head -n 3 "$SCRIPT"
530 head -n 3 "$SCRIPT"
530 . "$SCRIPT"
531 . "$SCRIPT"
531 done
532 done
532
533
533 ## Execute custom bootstrap scripts
534 ## Execute custom bootstrap scripts
534 if [ -d "custom.d" ] ; then
535 if [ -d "custom.d" ] ; then
535 for SCRIPT in custom.d/*.sh; do
536 for SCRIPT in custom.d/*.sh; do
536 . "$SCRIPT"
537 . "$SCRIPT"
537 done
538 done
538 fi
539 fi
539
540
540 # Execute custom scripts inside the chroot
541 # Execute custom scripts inside the chroot
541 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
542 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
542 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
543 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
543 chroot_exec /bin/bash -x <<'EOF'
544 chroot_exec /bin/bash -x <<'EOF'
544 for SCRIPT in /chroot_scripts/* ; do
545 for SCRIPT in /chroot_scripts/* ; do
545 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
546 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
546 $SCRIPT
547 $SCRIPT
547 fi
548 fi
548 done
549 done
549 EOF
550 EOF
550 rm -rf "${R}/chroot_scripts"
551 rm -rf "${R}/chroot_scripts"
551 fi
552 fi
552
553
553 # Remove c/c++ build environment from the chroot
554 # Remove c/c++ build environment from the chroot
554 chroot_remove_cc
555 chroot_remove_cc
555
556
556 # Remove apt-utils
557 # Remove apt-utils
557 if [ "$RELEASE" = "jessie" ] ; then
558 if [ "$RELEASE" = "jessie" ] ; then
558 chroot_exec apt-get purge -qq -y --force-yes apt-utils
559 chroot_exec apt-get purge -qq -y --force-yes apt-utils
559 fi
560 fi
560
561
561 # Generate required machine-id
562 # Generate required machine-id
562 MACHINE_ID=$(dbus-uuidgen)
563 MACHINE_ID=$(dbus-uuidgen)
563 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
564 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
564 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
565 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
565
566
566 # APT Cleanup
567 # APT Cleanup
567 chroot_exec apt-get -y clean
568 chroot_exec apt-get -y clean
568 chroot_exec apt-get -y autoclean
569 chroot_exec apt-get -y autoclean
569 chroot_exec apt-get -y autoremove
570 chroot_exec apt-get -y autoremove
570
571
571 # Unmount mounted filesystems
572 # Unmount mounted filesystems
572 umount -l "${R}/proc"
573 umount -l "${R}/proc"
573 umount -l "${R}/sys"
574 umount -l "${R}/sys"
574
575
575 # Clean up directories
576 # Clean up directories
576 rm -rf "${R}/run/*"
577 rm -rf "${R}/run/*"
577 rm -rf "${R}/tmp/*"
578 rm -rf "${R}/tmp/*"
578
579
579 # Clean up files
580 # Clean up files
580 rm -f "${ETC_DIR}/ssh/ssh_host_*"
581 rm -f "${ETC_DIR}/ssh/ssh_host_*"
581 rm -f "${ETC_DIR}/dropbear/dropbear_*"
582 rm -f "${ETC_DIR}/dropbear/dropbear_*"
582 rm -f "${ETC_DIR}/apt/sources.list.save"
583 rm -f "${ETC_DIR}/apt/sources.list.save"
583 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
584 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
584 rm -f "${ETC_DIR}/*-"
585 rm -f "${ETC_DIR}/*-"
585 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
586 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
586 rm -f "${ETC_DIR}/resolv.conf"
587 rm -f "${ETC_DIR}/resolv.conf"
587 rm -f "${R}/root/.bash_history"
588 rm -f "${R}/root/.bash_history"
588 rm -f "${R}/var/lib/urandom/random-seed"
589 rm -f "${R}/var/lib/urandom/random-seed"
589 rm -f "${R}/initrd.img"
590 rm -f "${R}/initrd.img"
590 rm -f "${R}/vmlinuz"
591 rm -f "${R}/vmlinuz"
591 rm -f "${R}${QEMU_BINARY}"
592 rm -f "${R}${QEMU_BINARY}"
592
593
593 if [ "$ENABLE_QEMU" = true ] ; then
594 if [ "$ENABLE_QEMU" = true ] ; then
594 # Configure qemu compatible kernel
595 # Configure qemu compatible kernel
595 DTB_FILE=vexpress-v2p-ca15_a7.dtb
596 DTB_FILE=vexpress-v2p-ca15_a7.dtb
596 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
597 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
597 KERNEL_DEFCONFIG="vexpress_defconfig"
598 KERNEL_DEFCONFIG="vexpress_defconfig"
598 if [ "$KERNEL_MENUCONFIG" = false ] ; then
599 if [ "$KERNEL_MENUCONFIG" = false ] ; then
599 KERNEL_OLDDEFCONFIG=true
600 KERNEL_OLDDEFCONFIG=true
600 fi
601 fi
601
602
602 # Setup QEMU directory
603 # Setup QEMU directory
603 mkdir "${BASEDIR}/qemu"
604 mkdir "${BASEDIR}/qemu"
604
605
605 # Copy kernel image to QEMU directory
606 # Copy kernel image to QEMU directory
606 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
607 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
607
608
608 # Copy kernel config to QEMU directory
609 # Copy kernel config to QEMU directory
609 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
610 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
610
611
611 # Copy kernel dtbs to QEMU directory
612 # Copy kernel dtbs to QEMU directory
612 for dtb in "${BOOT_DIR}/"*.dtb ; do
613 for dtb in "${BOOT_DIR}/"*.dtb ; do
613 if [ -f "${dtb}" ] ; then
614 if [ -f "${dtb}" ] ; then
614 install_readonly "${dtb}" "${BASEDIR}/qemu/"
615 install_readonly "${dtb}" "${BASEDIR}/qemu/"
615 fi
616 fi
616 done
617 done
617
618
618 # Copy kernel overlays to QEMU directory
619 # Copy kernel overlays to QEMU directory
619 if [ -d "${BOOT_DIR}/overlays" ] ; then
620 if [ -d "${BOOT_DIR}/overlays" ] ; then
620 # Setup overlays dtbs directory
621 # Setup overlays dtbs directory
621 mkdir "${BASEDIR}/qemu/overlays"
622 mkdir "${BASEDIR}/qemu/overlays"
622
623
623 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
624 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
624 if [ -f "${dtb}" ] ; then
625 if [ -f "${dtb}" ] ; then
625 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
626 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
626 fi
627 fi
627 done
628 done
628 fi
629 fi
629
630
630 # Copy u-boot files to QEMU directory
631 # Copy u-boot files to QEMU directory
631 if [ "$ENABLE_UBOOT" = true ] ; then
632 if [ "$ENABLE_UBOOT" = true ] ; then
632 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
633 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
633 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
634 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
634 fi
635 fi
635 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
636 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
636 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
637 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
637 fi
638 fi
638 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
639 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
639 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
640 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
640 fi
641 fi
641 fi
642 fi
642
643
643 # Copy initramfs to QEMU directory
644 # Copy initramfs to QEMU directory
644 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
645 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
645 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
646 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
646 fi
647 fi
647 fi
648 fi
648
649
649 # Calculate size of the chroot directory in KB
650 # Calculate size of the chroot directory in KB
650 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
651 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
651
652
652 # Calculate the amount of needed 512 Byte sectors
653 # Calculate the amount of needed 512 Byte sectors
653 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
654 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
654 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
655 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
655 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
656 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
656
657
657 # The root partition is EXT4
658 # The root partition is EXT4
658 # This means more space than the actual used space of the chroot is used.
659 # This means more space than the actual used space of the chroot is used.
659 # As overhead for journaling and reserved blocks 35% are added.
660 # As overhead for journaling and reserved blocks 35% are added.
660 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
661 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
661
662
662 # Calculate required image size in 512 Byte sectors
663 # Calculate required image size in 512 Byte sectors
663 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
664 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
664
665
665 # Prepare image file
666 # Prepare image file
666 if [ "$ENABLE_SPLITFS" = true ] ; then
667 if [ "$ENABLE_SPLITFS" = true ] ; then
667 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
668 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
668 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
669 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
669 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
670 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
670 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
671 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
671
672
672 # Write firmware/boot partition tables
673 # Write firmware/boot partition tables
673 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
674 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
674 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
675 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
675 EOM
676 EOM
676
677
677 # Write root partition table
678 # Write root partition table
678 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
679 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
679 ${TABLE_SECTORS},${ROOT_SECTORS},83
680 ${TABLE_SECTORS},${ROOT_SECTORS},83
680 EOM
681 EOM
681
682
682 # Setup temporary loop devices
683 # Setup temporary loop devices
683 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
684 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
684 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
685 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
685 else # ENABLE_SPLITFS=false
686 else # ENABLE_SPLITFS=false
686 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
687 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
687 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
688 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
688
689
689 # Write partition table
690 # Write partition table
690 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
691 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
691 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
692 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
692 ${ROOT_OFFSET},${ROOT_SECTORS},83
693 ${ROOT_OFFSET},${ROOT_SECTORS},83
693 EOM
694 EOM
694
695
695 # Setup temporary loop devices
696 # Setup temporary loop devices
696 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
697 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
697 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
698 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
698 fi
699 fi
699
700
700 if [ "$ENABLE_CRYPTFS" = true ] ; then
701 if [ "$ENABLE_CRYPTFS" = true ] ; then
701 # Create dummy ext4 fs
702 # Create dummy ext4 fs
702 mkfs.ext4 "$ROOT_LOOP"
703 mkfs.ext4 "$ROOT_LOOP"
703
704
704 # Setup password keyfile
705 # Setup password keyfile
705 touch .password
706 touch .password
706 chmod 600 .password
707 chmod 600 .password
707 echo -n ${CRYPTFS_PASSWORD} > .password
708 echo -n ${CRYPTFS_PASSWORD} > .password
708
709
709 # Initialize encrypted partition
710 # Initialize encrypted partition
710 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
711 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
711
712
712 # Open encrypted partition and setup mapping
713 # Open encrypted partition and setup mapping
713 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
714 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
714
715
715 # Secure delete password keyfile
716 # Secure delete password keyfile
716 shred -zu .password
717 shred -zu .password
717
718
718 # Update temporary loop device
719 # Update temporary loop device
719 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
720 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
720
721
721 # Wipe encrypted partition (encryption cipher is used for randomness)
722 # Wipe encrypted partition (encryption cipher is used for randomness)
722 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
723 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
723 fi
724 fi
724
725
725 # Build filesystems
726 # Build filesystems
726 mkfs.vfat "$FRMW_LOOP"
727 mkfs.vfat "$FRMW_LOOP"
727 mkfs.ext4 "$ROOT_LOOP"
728 mkfs.ext4 "$ROOT_LOOP"
728
729
729 # Mount the temporary loop devices
730 # Mount the temporary loop devices
730 mkdir -p "$BUILDDIR/mount"
731 mkdir -p "$BUILDDIR/mount"
731 mount "$ROOT_LOOP" "$BUILDDIR/mount"
732 mount "$ROOT_LOOP" "$BUILDDIR/mount"
732
733
733 mkdir -p "$BUILDDIR/mount/boot/firmware"
734 mkdir -p "$BUILDDIR/mount/boot/firmware"
734 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
735 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
735
736
736 # Copy all files from the chroot to the loop device mount point directory
737 # Copy all files from the chroot to the loop device mount point directory
737 rsync -a "${R}/" "$BUILDDIR/mount/"
738 rsync -a "${R}/" "$BUILDDIR/mount/"
738
739
739 # Unmount all temporary loop devices and mount points
740 # Unmount all temporary loop devices and mount points
740 cleanup
741 cleanup
741
742
742 # Create block map file(s) of image(s)
743 # Create block map file(s) of image(s)
743 if [ "$ENABLE_SPLITFS" = true ] ; then
744 if [ "$ENABLE_SPLITFS" = true ] ; then
744 # Create block map files for "bmaptool"
745 # Create block map files for "bmaptool"
745 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
746 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
746 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
747 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
747
748
748 # Image was successfully created
749 # Image was successfully created
749 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
750 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
750 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
751 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
751 else
752 else
752 # Create block map file for "bmaptool"
753 # Create block map file for "bmaptool"
753 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
754 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
754
755
755 # Image was successfully created
756 # Image was successfully created
756 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
757 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
757
758
758 # Create qemu qcow2 image
759 # Create qemu qcow2 image
759 if [ "$ENABLE_QEMU" = true ] ; then
760 if [ "$ENABLE_QEMU" = true ] ; then
760 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
761 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
761 QEMU_SIZE=16G
762 QEMU_SIZE=16G
762
763
763 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
764 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
764 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
765 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
765
766
766 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
767 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
767 fi
768 fi
768 fi
769 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant